package dao;

import java.util.Hashtable;

import model.Tag;
import exception.PersistenceException;

public interface TagDAO {
	
	public <T> T openPersistence();
	public <T> void closePersistence(T persistence);	
	
	public Integer salvar(Tag tag) throws PersistenceException;
	public void atualizar(Tag tag) throws PersistenceException;
	public Tag recuperarPorId(Integer codigoTag) throws PersistenceException;
	public Tag recuperarPorNome(String nomeTag) throws PersistenceException;
	public void remover(Integer codigoTag) throws PersistenceException;
	public Hashtable<String, Tag> recuperarTodos() throws PersistenceException;

}
