package factory;

import dao.DataFileDAO;
import dao.TagDAO;
import dao.TagFileDAO;

public abstract class DAOFactory {
	
	public static final int JDBC = 1;

	public abstract <T> T openConnection();
	public abstract <T> void closeConnection(T connection);
	public abstract <T> T getFactory();	
	
	public abstract DataFileDAO getDataFileDAO();
	public abstract TagDAO getTagDAO();
	public abstract TagFileDAO getTagFileDAO();

	public static DAOFactory getDAOfactory(int factoryType){
		switch (factoryType) {
		case 1:
			return JDBCDAOFactory.getInstance();
		default:
			return null;
		}
	}
	

}
