package model;

import java.util.ArrayList;
import java.util.Hashtable;

import dao.DataFileDAO;
import dao.TagDAO;
import dao.TagFileDAO;

public class MemoryManager {
	
	Hashtable <String, Tag> tags;
	Hashtable <String, DataFile> datafiles;
	ArrayList<TagFile> tagsfiles;

	
	/**
	 * Carrega em memoria as Tags existente no mecanismo de persistencia
	 */
	protected TagFile getTagFile(Integer idTag, Integer idFile) {
		try {
			for (TagFile tf : tagsfiles) {
				if (tf.idFile.compareTo(idFile) == 0 && tf.idTag.compareTo(idTag) == 0) {
					return tf;
				}
			}

			
		}
		catch (Exception e) {
			System.out.println(e);
		}
		return null;
	}
	
	/**
	 * Carrega em memoria as Tags existente no mecanismo de persistencia
	 */
	protected void loadTags(TagDAO tagDAO) {
		try {
			this.tags = tagDAO.recuperarTodos();
		}
		catch (Exception e) {
			System.out.println(e);
		}
	}
	
	/**
	 * Carrega em memoria os DataFiles existente no mecanismo de persistencia
	 */
	protected void loadDataFiles(DataFileDAO datafileDAO) {
		try {
			this.datafiles = datafileDAO.recuperarTodos();
		}
		catch (Exception e) {
			System.out.println(e);
		}
	}
	
	/**
	 * Carrega em memoria os TagFiles existente no mecanismo de persistencia
	 */
	protected void loadTagsFiles(TagFileDAO tagfileDAO) {
		try {
			this.tagsfiles = tagfileDAO.recuperarTodos();
		}
		catch (Exception e) {
			System.out.println(e);
		}
	}
	/**
	 * Associa os DataFiles com suas respectivas Tags
	 */
	protected void asociateTagsFiles() {
		for (TagFile tf : this.tagsfiles) {
			Tag t = this.tags.get(tf.getNameTag());
			DataFile df = this.datafiles.get(tf.getIdFile().toString());
			
			this.linkTagToDF(t, df);
			
		}
	}
	
	
	/**
	 * Associa a Tag t ao DataFile df
	 * Atualiza a associatedTags de cada Tag
	 * bug: No atualiza o tagsFiles
	 * bug:  necessrio mesmo o associatedTags?
	 */
	protected void linkTagToDF(Tag t, DataFile df) {
		t.addDataFile(df);
		df.addTag(t);
		/*
		for (Tag tag : df.getTags()) {
			t.associateTag(tag);
			if (t != tag)
				tag.associateTag(t);
		}
		*/
	}
	
	/**
	 * Uma representao em modo texto do Memory Manager
	 */
	public synchronized void printMemoryManager() {
		System.out.println("#########");
		for (String strDf : this.datafiles.keySet()) {
			DataFile df = this.datafiles.get(strDf);
			System.out.println(df);
			for (String strTag : df.tags.keySet()) {
				Tag t = this.tags.get(strTag);
				System.out.println(">" + t);
			}
		}
		System.out.println("#########");
		for (String strTag : this.tags.keySet()) {
			Tag t = this.tags.get(strTag);
			System.out.println(t);
			for (String strDf : t.dataFiles.keySet()) {
				DataFile df = this.datafiles.get(strDf);
				System.out.println(">" + df);
			}
		}
		System.out.println("#########");
			
		System.out.println("Tags");
		System.out.println(this.tags);
		System.out.println("DataFiles");
		System.out.println(this.datafiles);
		System.out.println("TagsFiles");
		System.out.println(this.tagsfiles);
		
	}
}

