package server;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.Vector;

import model.Core;
import model.DataFile;
import model.Tag;
import parser.Parser;

public class Job implements Runnable{


	protected PrintWriter pw = null;
	protected Core core = null;
	protected Socket client = null;
	   
	public Job(PrintWriter p, Core c, Socket cs) {

		pw = p;
		core = c;
		client = cs;
	}
	   
	public void run() {
		doTheJob();
	}

	/**
	 * Mtodo para executar o comando
	 */
	protected void doTheJob() {
		String commands;
		BufferedReader br = null;
		try {
			
			br = new BufferedReader(new InputStreamReader(
                        client.getInputStream())
                        );
			commands = br.readLine();
			while (commands.compareTo(Parser.ENDOFCOMMANDS) != 0) {
				String command;
				Vector<String> commandArgs = Parser.toParse(commands);
				command = commandArgs.get(0);
				commandArgs.remove(0);
					
				if (command.compareTo("sch1") == 0) {
					System.out.println(commandArgs);
					Vector<DataFile> dfs;
					dfs = core.buscaInterseccaoWrapper(commandArgs);
					pw.println(dfs.size());
					for (DataFile df : dfs)  pw.println(df);
					pw.flush();
				}
				else if (command.compareTo("sch2") == 0) {
					Vector<DataFile> dfs;
					dfs = core.buscaSemelhancaWrapper(commandArgs);
					pw.println(dfs.size());
					for (DataFile df : dfs)  pw.println(df);
					pw.flush();
				}
				else if (command.compareTo("addtd") == 0) {
					String tag = commandArgs.get(0);
					String path = commandArgs.get(1);
					String type = commandArgs.get(2);
					Tag t = core.createTag(tag);
					DataFile df = core.createDataFile(path, type);
					core.addTagToDataFile(t, df);
						
				}
				else if (command.compareTo("rmtagdf") == 0) {
					String tag = commandArgs.get(0);
					String path = commandArgs.get(1);
					core.removeTagFile(tag, path);
				}
				else if (command.compareTo("rmtag") == 0) {
					String tag = commandArgs.get(0);
					core.removeTag(tag);
				}
				else if (command.compareTo("rmdf") == 0) {
					String path = commandArgs.get(0);
					core.removeDataFile(path);
				}
				else {
					pw.println("1");
					pw.println("Comando invlido");
				}
				commands = br.readLine();
			}
			br.close();
			pw.close();
			client.close();
		   }
		   catch (Exception e) {
					System.out.println(e.getStackTrace());
		   }
	   }

}