package server;

import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;

import model.Core;

public class SMSDServer {
	
	private static SMSDServer instance = null;
	private static boolean done;
	Core core;
		
	protected SMSDServer() {}
		   
	public static SMSDServer getInstance() {
		if(instance == null) {
			instance = new SMSDServer();
		}
		return instance;
	}
	
	/**
	 * Inicializa o servico
	 */
	public void start(Integer port) {
		Core core = new Core();
		
		ServerSocket ss = null;
		Socket cs = null;
		PrintWriter pw = null;
			            
		try {
			done = false;
			ss = new ServerSocket(port);
			                  
			System.out.println("Server: Aguardando na porta " + ss.getLocalPort());

			while (!done) {

				cs = ss.accept();
				pw = new PrintWriter(cs.getOutputStream());
				Job job = new Job(pw, core, cs);
				new Thread(job).start();
			}      
			
		} catch (Exception e) {
			System.err.println(e);
		} finally {
			try {
				pw.close();
				cs.close();
				ss.close();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	/**
	 * Mtodo principal
	 * @param args
	 */
	public static void main(String args[]) {
		if (args.length < 1) {
			System.out.println("uso: SMSDServer <porta>");
			System.exit(0);
		}
		SMSDServer.getInstance().start(Integer.parseInt(args[0]));

	}
	
	/**
	 * Pra o servio
	 */
	public void shutDown() {
		done = true;
	}

}